part of insync;

abstract class ObservableCollection<V> extends AbstractCollection<V> {
  EventDispatcher get onClear;
  EventDispatcher get onChange;
  Property<int> get lengthProperty;

  ObservableList<dynamic> createEmptyList();
  ObservableMap<dynamic, dynamic> createEmptyMap();
  ObservableSet<dynamic> createEmptySet();

  // Next methods rise warning
  // https://code.google.com/p/dart/issues/detail?id=12238
  //ObservableCollection<V> $filter(bool f(V value));
  //ObservableCollection<dynamic> $map(dynamic f(V value));
  //ObservableCollection<dynamic> createEmpty();
}