part of insync;

class ObservableSetSorterComparing<V> extends AbstractSetSorterComparing<V> {
  ObservableSetSorterComparing(ObservableSet<V> source, {AbstractList<V> target,
    int compare(V x, V y)}) : super(source, target: target, compare: compare) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _splice(spliceResult.removedValues, spliceResult.addedValues);
  }

  void _onClear(List<V> values) {
    _splice(values, []);
  }
}