part of insync;

abstract class Owner extends Destroyable {
  List<Destroyable> _ownagePool = [];

  void own(Destroyable obj) {
    _ownagePool.add(obj);
  }

  void destroy() {
    assert(_ownagePool != null);
    List<Destroyable> pool = _ownagePool;
    _ownagePool = null;
    pool.reversed.forEach(Destroyable.destroyObject);
    super.destroy();
  }
}