part of insync;

class _ComponentChild {
  Component _parent;
  Component _child;
  String _id;
  Element _el;

  _ComponentChild(this._parent, this._child) {}

  void attach(String id) {
    assert(_id == null);
    _id = id;
    _el = _parent._rawEls[id];
    _parent._initChild(_child, _el);
    _parent._rawEls[id] = _child.el;
    _el.replaceWith(_child.el);
    _child.el.classes.addAll(_el.classes);
    _child._afterAppend();
  }

  void detach() {
    assert(_id != null);
    if (identical(_parent._rawEls[_id], _child.el)) {
      _parent._rawEls[_id] = _el;
    }
    _child.el.replaceWith(_el);
    _parent._doneChild(_child);
    _el = null;
    _id = null;
  }
}