part of insync;

class HtmlUpdater extends Destroyable {
  final Element el;
  final Property<String> property;

  EventAttachment _attachment;

  HtmlUpdater(this.el, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    el.innerHtml = property.value;
  }
}