part of insync;

class StyleUpdater extends Destroyable {
  final Element el;
  final String style;
  final Property<String> property;

  EventAttachment _attachment;

  StyleUpdater(this.el, this.style, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    el.style.setProperty(style, property.value);
  }
}