part of insync;

class ValueUpdater extends Destroyable {
  final InputElement el;
  final Property<String> property;

  EventAttachment _attachment;

  ValueUpdater(this.el, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    el.value = property.value;
  }
}