part of insync;

class AbstractMapFilterer<K, V> extends AbstractCollectionFilterer<V, AbstractMap<K, V>> {
  AbstractMapFilterer(AbstractMap<K, V> source, {AbstractMap<K, V> target, bool filter(V value)}) :
    super(source, target: target, filter: filter) {
    _target.trySetAll(source.filter(_filterValue));
  }

  void destroy() {
    _target.tryRemoveAll(_source.getKeys());
    super.destroy();
  }
}