part of insync;

class WrapMap<K, V> implements Map<K, V> {
  Map<K, V> _map;

  WrapMap(this._map) {}

  WrapMap.empty() : _map = new HashMap<K, V>() {}

  bool containsValue(V value) => _map.containsValue(value);
  bool containsKey(K key) => _map.containsKey(key);
  V operator [](K key) => _map[key];
  Iterable<K> get keys => _map.keys;
  Iterable<V> get values => _map.values;
  int get length => _map.length;
  bool get isEmpty => _map.isEmpty;
  bool get isNotEmpty => _map.isNotEmpty;

  void operator []=(K key, V value) { _map[key] = value; }
  void addAll(Map<K, V> other) => _map.addAll(other);
  V putIfAbsent(K key, V ifAbsent()) => _map.putIfAbsent(key, ifAbsent);
  V remove(K key) => _map.remove(key);
  void clear() => _map.clear();
  void forEach(void f(K key, V value)) => _map.forEach(f);
}