part of insync;

class WrapSet<E> extends WrapIterable<E> implements Set<E> {
  Set<E> _set;

  Set<E> get base => _set;

  WrapSet(Set<E> set) : super(set), _set = set {}

  bool contains(E value) => _set.contains(value);
  bool containsAll(Iterable<E> other) => _set.containsAll(other);
  Set<E> intersection(Set<E> other) => _set.intersection(other);
  Set<E> union(Set<E> other) => _set.union(other);
  Set<E> difference(Set<E> other) => _set.difference(other);

  bool add(E value) => _set.add(value);
  void addAll(Iterable<E> elements) => _set.addAll(elements);
  bool remove(Object value) => _set.remove(value);
  E lookup(Object value) => _set.lookup(value);
  void removeAll(Iterable elements) => _set.removeAll(elements);
  void retainAll(Iterable elements) => _set.retainAll(elements);
  void removeWhere(bool test(E element)) => _set.removeWhere(test);
  void retainWhere(bool test(E element)) => _set.retainWhere(test);
  void clear() => _set.clear();
}