part of insync;

/**
 * @todo Rewrite on typedef when buddies will fix all bugs.
 */
class ValueEventParams<V> {
  final V value;
  const ValueEventParams(this.value);
}

class ValueChangeEventParams<V> extends ValueEventParams<V> {
  final V oldValue;
  const ValueChangeEventParams(V value, this.oldValue) : super(value);
}

class ItemEventParams<I> {
  final I item;
  const ItemEventParams(this.item);
}

class ItemValueEventParams<I, V> extends ValueEventParams<V> {
  final I item;
  const ItemValueEventParams(this.item, V value) : super(value);
}