part of insync;

class ComponentReplaceable extends Destroyable {
  Component _parent;
  String _id;
  PropertySwitcher _switcher;

  ComponentReplaceable(this._parent, Property<Component> source, this._id) {
    _parent._replaceables.add(this);
    _switcher = new PropertySwitcher([source],
        create: (Component child) {
          _parent.children[_id] = child;
        },
        destroy: (unused, Component child) {
          _parent.children.remove(_id);
        }
    );
  }

  void destroy() {
    _switcher.destroy();
    _parent._replaceables.remove(this);
    super.destroy();
  }
}