part of insync;

class ElementUtil {
  static Element queryParent(Element el, String selector) {
    el = el.parent;
    while (el != null) {
      if (el.matches(selector)) {
        return el;
      }
      el = el.parent;
    }
    return null;
  }

  static void setXY(Element el, int x, int y) {
    el.style.left = x.toString() + 'px';
    el.style.top = y.toString() + 'px';
  }

  static void setXYPoint(Element el, Point xy) {
    setXY(el, xy.x, xy.y);
  }

  static void setSize(Element el, int width, int height) {
    el.style.width = width.toString() + 'px';
    el.style.height = height.toString() + 'px';
  }

  static void setSizeByPoint(Element el, Point size) {
    setSize(el, size.x, size.y);
  }

  static void setLocation(Element el, Rectangle rect) {
    setXY(el, rect.left, rect.top);
    setSize(el, rect.width, rect.height);
  }
}