part of insync;

class ValueListener extends Owner {
  final InputElement el;

  Property<String> _target;
  Property<String> get target => _target;

  ValueListener(this.el, {Property<String> target}) {
    _target = (target != null) ? target : new Property<String>()..ownBy(this);
    _update();
    own(new Subscription(el.onInput.listen(_update)));
  }

  void _update([Event event]) {
    _target.value = el.value;
  }
}